"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const query_1 = require("./query");
class Client {
    constructor(db) {
        this.db = db;
    }
    count(table) {
        return query_1.count(table, (sql, resolve, reject) => {
            this.db.query(sql, (err, results) => {
                if (err) {
                    reject(err);
                }
                else {
                    resolve(results[0].count);
                }
            });
        });
    }
    select(columns) {
        return query_1.select(columns, createExecutor(this.db));
    }
    insertInto(table) {
        return query_1.insertInto(table, createExecutor(this.db));
    }
    deleteFrom(table) {
        return query_1.deleteFrom(table, createExecutor(this.db));
    }
    update(table) {
        return query_1.update(table, createExecutor(this.db));
    }
    end() {
        return new Promise((resolve, reject) => {
            this.db.end((err) => {
                if (err) {
                    reject(err);
                }
                else {
                    resolve();
                }
            });
        });
    }
}
exports.Client = Client;
function createExecutor(db) {
    return (sql, resolve, reject) => {
        db.query(sql, (err, results) => {
            if (err) {
                reject(err);
            }
            else {
                resolve(results);
            }
        });
    };
}
//# sourceMappingURL=client.js.map