export interface IResult {
    fieldCount: number;
    affectedRows: number;
    insertId: number;
    serverStatus: number;
    warningCount: number;
    message: string;
    protocol41: boolean;
    changedRows: number;
}
export interface ICount extends Promise<number> {
    where(condiction: string): ICount;
    where(...condictions: object[]): ICount;
}
export interface ISelect extends Promise<object[]> {
    from(table: string): ISelect;
    where(condiction: string): ISelect;
    where(...condictions: object[]): ISelect;
    groupBy(column: string): ISelect;
    orderBy(...orders: Array<[string, number]>): ISelect;
    limit(limit: number): ISelect;
    offset(offset: number): ISelect;
}
export interface IInsert extends Promise<IResult> {
    values(values: object[]): IInsert;
}
export interface IDelete extends Promise<IResult> {
    where(condiction: string): IDelete;
    where(...condictions: object[]): IDelete;
    limit(limit: number): IDelete;
    offset(offset: number): IDelete;
}
export interface IUpdate extends Promise<IResult> {
    where(condiction: string): IUpdate;
    where(...condictions: object[]): IUpdate;
    set(value: object): IUpdate;
}
export declare function select(columns: string[] | string, exec: (sql: any, resolve: any, reject: any) => void): ISelect;
export declare function count(table: string, exec: (sql: any, resolve: any, reject: any) => void): ICount;
export declare function insertInto(table: any, exec: (sql: any, resolve: any, reject: any) => void): IInsert;
export declare function deleteFrom(table: string, exec: (sql: any, resolve: any, reject: any) => void): IDelete;
export declare function update(table: string, exec: (sql: any, resolve: any, reject: any) => void): IUpdate;
